-- functions.lua
-- Written By Habna


function Add()
	import "HabnaPlugins.HugeBag.swappable"; -- LUA swappable Menu file
	frmSwappable();
end

-- **v Show Help Info v**
function UnloadHugeBag()
	--write( "HugeBag: Unloaded" );
	--Turbine.PluginManager.UnloadScriptState( "HugeBag" );
end
-- **^
-- **v Show Help Info v**
function ReloadHugeBag()
	--UnloadHugeBag();
	--LoadHugeBag();
end
-- **^
-- **v Toggle the ability to hide are not HugeBag when the 'esc' key is press v**
function ToggleWEsc()
	if HBW then
		write( "HugeBag: This option is disable when using the wrapper" );
	else
		HideWEsc = ( not HideWEsc );
		SaveSettings();
		if ( HideWEsc ) then
			write( "HugeBag: I will hide when 'esc' key is press" );
		else
			write( "HugeBag: I will stay visible when 'esc' key is press" );
		end
	end
end
-- **^
-- **v Toggle Startup Visibility v**
function ToggleShow()
	if HBW then
		write( "HugeBag: This option is disable when using the wrapper" );
	else
		StartVisible = ( not StartVisible );
		SaveSettings();
		if ( StartVisible ) then
			write( "HugeBag: I will load visibile next time" );
		else
			write( "HugeBag: I will load hidden next time" );
		end
	end
end
-- **^
-- **v Toggle to use widget mode are not v**
function ToggleWidgetMode()
	Widget = ( not Widget );
	SaveSettings();
	if ( Widget ) then
		write( "HugeBag: Will load in widget mode next time" );
	else
		write( "HugeBag: Will load in window mode next time" );
	end
end
-- **^
-- **v Toggle ability to be always on top are not v**
function ToggleAlwaysOnTop()
	zOrder = ( not zOrder );
	SaveSettings();
	if ( zOrder ) then
		write( "HugeBag: Will be always on top" );
	else
		write( "HugeBag: Will not be always on top" );
	end
end
-- **v Show About window v**
function ShowAbout()
	import "HabnaPlugins.HugeBag.About"; -- LUA frmAbout file
	frmAbout();
end
-- **^
-- **v Set background color v**
function SetBackgroundColor()
	import "HabnaPlugins.HugeBag.background"; -- LUA background file
	frmBackground();
end
-- **^
-- **v Show Shell Command window v**
function HelpInfo()
	import "HabnaPlugins.HugeBag.ShellCmd"; -- LUA frmShellCmd file
	frmShellCmd();
end
-- **^
-- **v Move button to left v**
function MoveButtonLeft()
	MoveTo = "left";
	MoveButton();
end
-- **^
-- **v Move button to right v**
function MoveButtonRight()
	MoveTo = "right";
	MoveButton();
end
-- **^
-- **v Move button to right v**
function MoveButton()
	LeftPos = MidPos - 50;
	RightPos = MidPos + 50;
	if ( MoveTo == "left" ) then
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == LeftPos then
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == LeftPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		end
	else
		if FromButton == "Sort" then
			if MergeButton:GetLeft() == RightPos then
				SortLeft = RightPos;
				SearchLeft = LeftPos;
				MergeLeft = MidPos;
			else
				SortLeft = RightPos;
				SearchLeft = MidPos;
				MergeLeft = LeftPos;
			end
		elseif FromButton == "Search" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = RightPos;
				MergeLeft = LeftPos;
			else
				SortLeft = LeftPos;
				SearchLeft = RightPos;
				MergeLeft = MidPos;
			end
		elseif FromButton == "Merge" then
			if SortButton:GetLeft() == RightPos then
				SortLeft = MidPos;
				SearchLeft = LeftPos;
				MergeLeft = RightPos;
			else
				SortLeft = LeftPos;
				SearchLeft = MidPos;
				MergeLeft = RightPos;
			end
		end
	end

	if ( ButtonAtTop ) then
		TopPos = 22;
	else
		TopPos = frmMain:GetHeight() - 16;
		if Widget then TopPos = 8; end
	end
	SortButton:SetPosition( SortLeft,  TopPos ); --> ** Replace 'Sort' button with HugeBag height **
	SearchButton:SetPosition( SearchLeft,  TopPos ); --> ** Replace 'Search' button with HugeBag height **
	MergeButton:SetPosition( MergeLeft, TopPos ); --> ** Replace 'Merge' button with HugeBag height **
	SaveSettings();
end
-- **^

-- Create ten hacky resize cursors
function createCursor( cursorName, xOffset, yOffset, xSize, ySize )
	cursor = Turbine.UI.Window();
	cursor:SetSize( xSize, ySize );
	cursor:SetBackground( "HabnaPlugins/HugeBag/Resources/"..cursorName..".tga" );
	cursor:SetMouseVisible( false );
	cursor:SetZOrder( 10 );
	
	cursor.xOffset = xOffset;
	cursor.yOffset = yOffset;
	
	return cursor;
end

updownCursor = createCursor( "arrow_updown", 12, 12, 24, 24 );
up_down_right_clic = createCursor( "up_down_right_clic", 12, 12, 39, 24 );
resizeCursor = createCursor( "resize", 12, 12, 24, 24 );
rightclicCursor = createCursor( "right_clic", 12, 12, 24, 24 );
lotroresizeCursor = createCursor( "lotro_resize", 12, 12, 24, 24 );

function ShowLotroResizeCursor()
	if not LockPosition then
		frmMain.cursor = lotroresizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		frmMain.cursor:SetPosition( mouseX - frmMain.cursor.xOffset, mouseY - frmMain.cursor.yOffset);
		frmMain.cursor:SetVisible( true );
	end
end

function ShowResizeCursor()
	if not LockSize then
		frmMain.cursor = resizeCursor;
		local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
		frmMain.cursor:SetPosition( mouseX - frmMain.cursor.xOffset, mouseY - frmMain.cursor.yOffset);
		frmMain.cursor:SetVisible( true );
	end
end

function mergetable(table1,list)
	for i = 1, #list do
		table2 = list[i];
		local LenTable1 = #table1;
		for a = LenTable1 + 1, #table1 + #table2 do
			table1[a] = table2[a - LenTable1];
		end
	end
end

function ChangeColor()
	frmMain.itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, curSelRed, curSelGreen, curSelBlue ) );
end

function WrapperChecker()
	Turbine.PluginManager.RefreshAvailablePlugins();
	local loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();
	HBW, HBU = false, false;

	for k,v in pairs(loaded_plugins) do
		if v.Name == "HugeBag Wrapper" then
			HBW = true;
		elseif v.Name == "HugeBag Utilities" then
			HBU = true;
		end
	end
end

function isInArray(tCat, value)
	for n = 1, #tCat do
		if tCat[n] == value then
			ItemKey = n;
			--ItemCount = ItemCount + 1;
			return true
		end
	end
	return false
end

function table.RemoveDuplicate()
	j = 0;
	
	for i = 1, #ttable do
		if ttable[i] ~= PrevValue  then
			j = j + 1;
			tCat[j] = ttable[i];
			PrevValue = ttable[i];
		end
	end
end