-- optionsWidget.lua
-- Written By Habna


-- **v Set context menu items v**
local LocMenu = Turbine.UI.MenuItem( "Set HugeBag widget location to..." );
local LocMenuItems = LocMenu:GetItems();
LocItems = {};

LocItems[1] = Turbine.UI.MenuItem( "right" );
LocItems[1].Click = WidLocRight;

LocItems[2] = Turbine.UI.MenuItem( "left" );
LocItems[2].Click = WidLocLeft;

for i = 1, 2 do
	LocMenuItems:Add( LocItems[i] );
end

menu = Turbine.UI.ContextMenu();
menu.items = menu:GetItems();

local option_line = Turbine.UI.MenuItem("-----------------------------------------------------------------------", false, "line");

local option_toggleshow = Turbine.UI.MenuItem("Toggle the startup visibility of HugeBag", true, "visible");
option_toggleshow.Click = ToggleShow;

local option_togglewesc = Turbine.UI.MenuItem("Toggle hide event when the 'esc' key is press", true, "wesc");
option_togglewesc.Click = ToggleWEsc;

local option_togglewidget = Turbine.UI.MenuItem("Toggle from 'widget' and 'window' mode", true, "mode");
option_togglewidget.Click = ToggleWidgetMode;

local option_toggleaot = Turbine.UI.MenuItem("Toggle HugeBag 'Always On Top' ability", true, "aot");
option_toggleaot.Click = ToggleAlwaysOnTop;

local option_help = Turbine.UI.MenuItem("Show HugeBag widget shell commands", true, "help");
option_help.Click = HelpInfo;

local option_resetall = Turbine.UI.MenuItem("Reset all settings to default", true, "resetall");
option_resetall.Click = ResetSettings;

local option_add = Turbine.UI.MenuItem("Add/Remove Swappable Item", true, "add");
option_add.Click = Add;

local option_backcolor = Turbine.UI.MenuItem("Set HugeBag widget background color", true, "backcolor");
option_backcolor.Click = SetBackgroundColor;
--[[
local option_reload = Turbine.UI.MenuItem("Reload HugeBag plugin instance", true, "reload");
option_reload.Click = ReloadHugeBag;

local option_unload = Turbine.UI.MenuItem("Unload HugeBag plugin from memory", true, "unload");
option_unload.Click = UnloadHugeBag;
]]
local option_about = Turbine.UI.MenuItem("About HugeBag", true, "about");
option_about.Click = ShowAbout;

menu.items:Add(option_togglewidget);
menu.items:Add(option_toggleshow);
menu.items:Add(option_togglewesc);
menu.items:Add(option_toggleaot);
menu.items:Add(option_line); ------
menu.items:Add(option_add);
menu.items:Add(option_backcolor);
menu.items:Add(LocMenu);
menu.items:Add(option_line); ------
--menu.items:Add(option_reload);
--menu.items:Add(option_unload);
menu.items:Add(option_help);
menu.items:Add(option_resetall);
menu.items:Add(option_about);
-- **^